# GONE


Get all files

```bash


cp -r /Programs/GONE/Linux .

cp ../GATK/VCF_Filter/SPI_BJO_ROS_NU_Snps.Autosomes.filtered4.vcf.gz .

zcat SPI_BJO_ROS_NU_Snps.Autosomes.filtered4.vcf.gz | grep -v "#" | wc -l

# make ped and map files for each pop
module purge
module load VCFtools/0.1.16-intel-2018b-Perl-5.28.0
module load BCFtools/1.9-intel-2018b

bcftools query -l SPI_BJO_ROS_NU_Snps.Autosomes.filtered4.vcf.gz > samples

grep "BJO" samples > bjornoya
grep "ROS" samples > rost
grep "SPI" samples > spitsbergen

bcftools view -S bjornoya -O z -o BJO_NU_Snps.Autosomes.filtered4.vcf.gz SPI_BJO_ROS_NU_Snps.Autosomes.filtered4.vcf.gz
bcftools view -S rost -O z -o ROS_NU_Snps.Autosomes.filtered4.vcf.gz SPI_BJO_ROS_NU_Snps.Autosomes.filtered4.vcf.gz
bcftools view -S spitsbergen -O z -o SPI_NU_Snps.Autosomes.filtered4.vcf.gz SPI_BJO_ROS_NU_Snps.Autosomes.filtered4.vcf.gz

for pop in BJO ROS SPI ;
do echo ${pop} ;
bcftools filter -e 'AC==0 || AC==12' -O z -o ${pop}_NU_Snps.Autosomes.filtered4.edit.vcf.gz ${pop}_NU_Snps.Autosomes.filtered4.vcf.gz
bcftools view -H ${pop}_NU_Snps.Autosomes.filtered4.edit.vcf.gz | cut -f 1 | uniq | awk '{print $0"\t"$0}' > ${pop}_NU_Snps.Autosomes.filtered4.edit.chrom-map.txt
vcftools --gzvcf ${pop}_NU_Snps.Autosomes.filtered4.edit.vcf.gz --plink --chrom-map ${pop}_NU_Snps.Autosomes.filtered4.edit.chrom-map.txt --out ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf
#Update ped and map
cat ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.map | sed 's/Chr_0//g' | sed 's/Chr_//g' | sed 's/:/_/g' > ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.edit.map
cat ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.ped | awk '{print "1\t"$1"\t"$3"\t"$4"\t1\t-9"}' > tmp
cat ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.ped | cut -f 7- | paste tmp - > ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.edit.ped
rm tmp
cat ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.edit.ped | tr '\t' ' ' > ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.edit2.ped
cat ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.edit.map | tr '\t' ' ' > ${pop}_NU_Snps.Autosomes.filtered4.edit2.vcf.edit2.map
done


#Need to downsample
mkdir Downsample

cd Downsample

module purge
module load VCFtools/0.1.16-intel-2018b-Perl-5.28.0
module load BCFtools/1.9-intel-2018b

#Downsample all to 500k SNPs (100x)
for pop in BJO ROS SPI ;
do echo ${pop} ;
cp ../${pop}_NU_Snps.Autosomes.filtered4.edit.vcf.gz .
bcftools index ${pop}_NU_Snps.Autosomes.filtered4.edit.vcf.gz 
done

for pop in BJO ROS SPI ;
do echo $pop ;
for rep in {001..100} ;
do echo ${rep} ;
sbatch Downsample.sh $pop $rep ;
done
done

```

Downsample.sh

```bash

module purge
module load VCFtools/0.1.16-intel-2018b-Perl-5.28.0
module load BCFtools/1.9-intel-2018b

mkdir ${1}_${2}
cd ${1}_${2}

cp ../${1}_NU_Snps.Autosomes.filtered4.edit.vcf.gz .
cp ../${1}_NU_Snps.Autosomes.filtered4.edit.vcf.gz.csi .

touch ${1}.sites.sub_${2}
for chr in {01..24} ;
do echo $chr ;
bcftools view -H ${1}_NU_Snps.Autosomes.filtered4.edit.vcf.gz | cut -f 1,2 | grep -w "Chr_${chr}" | shuf -n 500000 - >> ${1}.sites.sub_${2} ; 
done

bcftools view -R ${1}.sites.sub_${2} -O z -o ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.vcf.gz ${1}_NU_Snps.Autosomes.filtered4.edit.vcf.gz 
bcftools sort -O z -o ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.sorted.vcf.gz ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.vcf.gz 
bcftools index ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.sorted.vcf.gz

bcftools view -H ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.sorted.vcf.gz | cut -f 1 | uniq | awk '{print $0"\t"$0}' > ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.chrom-map.txt
vcftools --gzvcf ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.sorted.vcf.gz --plink --chrom-map ${1}_NU_Snps.Autosomes.filtered4.edit.sub_${2}.chrom-map.txt --out ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf
cat ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.map | sed 's/Chr_0//g' | sed 's/Chr_//g' | sed 's/:/_/g' > ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit.map
cat ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.ped | awk '{print "1\t"$1"\t"$3"\t"$4"\t1\t-9"}' > tmp_sub_${2}
cat ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.ped | cut -f 7- | paste tmp_sub_${2} - > ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit.ped
rm tmp_sub_${2}
cat ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit.ped | tr '\t' ' ' > ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.ped
cat ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit.map | tr '\t' ' ' > ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.map

cd ../

mv ${1}_${2}/${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.ped .
mv ${1}_${2}/${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.map .
mv ${1}_${2}/${1}.sites.sub_${2} .

rm -r ${1}_${2}/

 

```

Then

```bash

mkdir Results

# using a constant recomb rate based on https://onlinelibrary.wiley.com/doi/10.1111/mec.12810
# Table 5
1-3: 1.6 -> 0.00000001600000000000
4-6: 2.0 -> 0.00000002000000000000
7-13: 1.7 -> 0.00000001700000000000
14-16: 1.5 -> 0.00000001500000000000
17-24: 1.5 -> 0.00000001500000000000
# -> 1.63 cM/Mb -> 0.0163 M/Mb

nano ../Linux/INPUT_PARAMETERS_FILE

chmod 555 ../Linux/PROGRAMMES/*

for pop in SPI BJO ROS ;
do echo ${pop} ;
for rep in {01..100} ;
do echo ${rep} ;
mkdir Results/${pop}_${rep} ;
sbatch GONE.sh ${pop} ${rep} ;
done
done

```

GONE.sh

```bash

module load GCC/7.3.0-2.30

mkdir temp.${1}_${2}

cd temp.${1}_${2}
cp -r ../../Linux/* .
rm example.map
rm example.ped
cp ../${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.ped .
mv ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.ped ${1}.ped
cp ../${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.map .
mv ${1}_NU_Snps.Autosomes.filtered4.edit2.sub_${2}.vcf.edit2.map ${1}.map

bash script_GONE.sh ${1} 

mv * ../Results/${1}_${2}/

cd ../

rm -r temp.${1}_${2}

```

Collect all output

```bash

cd Results

for pop in SPI BJO ROS ;
do echo ${pop} ;
touch ${pop}_GONE_100reps_summary
for rep in {01..100} ;
do echo ${rep} ;
for i in {1..40} ;
do echo ${i} ;
cut -f2 ${pop}_${rep}/TEMPORARY_FILES/outfileLD_TEMP/outfileLD_${i}_GONE_Nebest | paste ${pop}_GONE_100reps_summary - >> ${pop}_GONE_100reps_summary.edit ;
mv ${pop}_GONE_100reps_summary.edit ${pop}_GONE_100reps_summary
done
done
done 


```