# f4, fd, chromo paint

Call SNPs single sample 

```bash
mkdir f4_fd
cd f4_fd

cp RAZ_Puff_Variant/SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit2.vcf.gz .
zcat SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit2.vcf.gz | grep -v "#" | wc -l

module purge
module load BCFtools/1.9-intel-2018b

bcftools query -l SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit2.vcf.gz | awk '{ if (NR <= 17) {sp=substr($1,1,3); print $1"\t"sp} else {print $1"\tOutgroup";}}' > species_sets.txt

mkdir tmp
bcftools sort -o SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz -O z -T tmp SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit2.vcf.gz
bcftools index SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz

for i in {01..24} ;
do echo $i ;
bcftools view -r Chr_${i} -O z -o SPI_BJO_ROS_NoRelate_NU_Snps.Chr_${i}.withOutgroup.edit.sorted.vcf.gz SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz ;
done

for i in {01..24} ;
do echo $i ;
sbatch Dsuite1.sh ${i} ; 
done ;

```

Dsuite1.sh

```bash

module purge
module load Dsuite/20210309-GCC-9.3.0

Dsuite Dtrios -o SPI_BJO_ROS_NoRelate_RAZ_Chr${1} -n Run01 SPI_BJO_ROS_NoRelate_NU_Snps.Chr_${1}.withOutgroup.edit.sorted.vcf.gz species_sets.txt
```

Then

```bash

#combine results
module purge
module load Dsuite/20210309-GCC-9.3.0

echo -e "SPI_BJO_ROS_NoRelate_RAZ_Chr01_Run01" > CommandFile
for i in {02..24} ;
do echo $i ;
echo -e "SPI_BJO_ROS_NoRelate_RAZ_Chr${i}_Run01" > tmp ;
paste -d ' ' CommandFile tmp > CommandFile2
mv CommandFile2 CommandFile ;
rm tmp ;
done

Command=$(cat CommandFile | head )
Dsuite DtriosCombine -o SPI_BJO_ROS_NoRelate_RAZ_Autosomes -n FirstRunAutosomes ${Command}

#fd etc.

module purge
module load Dsuite/20210309-GCC-9.3.0

touch TriosForInvestigate_ROSinBJO.txt
echo -e "SPI\tBJO\tROS" >> TriosForInvestigate_ROSinBJO.txt

Dsuite Dinvestigate -w 1000,500 SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz species_sets.txt TriosForInvestigate_ROSinBJO.txt > ROSinBJO_fd_1000_500.out

touch TriosForInvestigate_SPIinBJO.txt
echo -e "ROS\tBJO\tSPI" >> TriosForInvestigate_SPIinBJO.txt
Dsuite Dinvestigate -w 1000,500 SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz species_sets.txt TriosForInvestigate_SPIinBJO.txt > SPIinBJO_fd_1000_500.out

touch TriosForInvestigate_SPIinROS.txt
echo -e "BJO\tROS\tSPI" >> TriosForInvestigate_SPIinROS.txt
Dsuite Dinvestigate -w 1000,500 SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz species_sets.txt TriosForInvestigate_SPIinROS.txt > SPIinROS_fd_1000_500.out

touch TriosForInvestigate_BJOinSPI.txt
echo -e "ROS\tSPI\tBJO" >> TriosForInvestigate_BJOinSPI.txt
Dsuite Dinvestigate -w 1000,500 SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.withOutgroup.edit.sorted.vcf.gz species_sets.txt TriosForInvestigate_BJOinSPI.txt > BJOinSPI_fd_1000_500.out

#ChromoPaint

mkdir Chromopaint
cd Chromopaint

module purge
module load BCFtools/1.9-intel-2018b

bcftools query -l SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.filtered4.vcf.gz > samples
cat samples | grep "ROS" > ros
cat ros | tr '\n' ',' > ros_edit
cat samples | grep "BJO" > bjo
cat bjo | tr '\n' ',' > bjo_edit
cat samples | grep "SPI" > spi
cat spi | tr '\n' ',' > spi_edit

#manually remove the last comma in each file
#then

paste -d ' ' ros_edit bjo_edit > tmp
paste -d ' ' tmp spi_edit > CommandFile
rm tmp 

gunzip -c SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.filtered4.vcf.gz > SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.filtered4.vcf

module purge
#module load Ruby/2.7.2-GCCcore-9.3.0
module load Ruby/3.0.1-GCCcore-10.3.0

Command=$(cat CommandFile | head )

#scripts from https://github.com/millanek/tutorials/tree/master/analysis_of_introgression_with_snp_data#ReconstructingFromSimulation
nano get_fixed_site_gts.rb
nano plot_fixed_site_gts.rb

ruby get_fixed_site_gts.rb SPI_BJO_ROS_NoRelate_NU_Snps.Autosomes.filtered4.vcf SPI_BJO_ROS.fixed.txt ${Command} 1.0

ruby plot_fixed_site_gts.rb SPI_BJO_ROS.fixed.txt SPI_BJO_ROS.fixed.svg 1.0 1 > Chromopaint.out

cp SPI_BJO_ROS.fixed.txt SPI_BJO_ROS.fixed_edit.txt
nano SPI_BJO_ROS.fixed_edit.txt
ruby plot_fixed_site_gts.rb SPI_BJO_ROS.fixed_edit.txt SPI_BJO_ROS.fixed_edit.svg 1.0 1 > Chromopaint_edit.out


```

```bash

#DO another run with Dsuite, this time specifying the assumed tree 
#SPI splits first, then BJO ROS

echo -e "(((ROS,BJO),SPI),Outgroup);" > Tree_assumed.nwk

for i in {01..24} ;
do echo $i ;
sbatch Dsuite2.sh ${i} ; 
done ;

```

Dsuite2.sh

```bash


module purge
module load Dsuite/20210309-GCC-9.3.0

Dsuite Dtrios -o SPI_BJO_ROS_NoRelate_RAZ_Chr${1} -n Run02 -t Tree_assumed.nwk SPI_BJO_ROS_NoRelate_NU_Snps.Chr_${1}.withOutgroup.edit.sorted.vcf.gz species_sets.txt

```

THEN

```bash

#combine results
module purge
module load Dsuite/20210309-GCC-9.3.0

echo -e "SPI_BJO_ROS_NoRelate_RAZ_Chr01_Run02" > CommandFile2
for i in {02..24} ;
do echo $i ;
echo -e "SPI_BJO_ROS_NoRelate_RAZ_Chr${i}_Run02" > tmp ;
paste -d ' ' CommandFile2 tmp > CommandFile3
mv CommandFile3 CommandFile2 ;
rm tmp ;
done

Command=$(cat CommandFile2 | head )
Dsuite DtriosCombine -o SPI_BJO_ROS_NoRelate_RAZ_Autosomes -n SecondRunAutosomes -t Tree_assumed.nwk ${Command}

```
