# Chromopaint Globetrotter


-> Phased genomes from LHR pipeline

-> then start process
 

```bash

mkdir Globetrotter
cd Globetrotter

cp SPI_BJO_ROS.NoRelate.Chr_*.phased.vcf.gz* .

module purge
module load BCFtools/1.9-intel-2018b
for i in {01..24} ;
do echo ${i} ;
bcftools convert SPI_BJO_ROS.NoRelate.Chr_${i}.phased.vcf.gz --hapsample Chr_${i}
gunzip Chr_${i}.hap.gz
mv Chr_${i}.hap Chr_${i}.haps
done

module purge
module load Perl/5.34.0-GCCcore-11.2.0
for i in {01..24} ;
do echo ${i} ;
perl impute2chromopainter2.pl Chr_${i}.haps Chr_${i}.chromo
perl makeuniformrecfile.pl Chr_${i}.chromo.phase Chr_${i}.chromo.rec
done ;

# using a constant recomb rate based on https://onlinelibrary.wiley.com/doi/10.1111/mec.12810
# Table 5
1-3: 1.6 -> 0.00000001600000000000
4-6: 2.0 -> 0.00000002000000000000
7-13: 1.7 -> 0.00000001700000000000
14-16: 1.5 -> 0.00000001500000000000
17-24: 1.5 -> 0.00000001500000000000
# -> 1.63 cM/Mb -> 0.0163 M/Mb

for i in {01..03} ;
do echo $i ;
sed 's/0.00000010000000000000/0.00000001600000000000/g' Chr_${i}.chromo.rec > Chr_${i}.chromo.edit.rec
done
for i in {04..06} ;
do echo $i ;
sed 's/0.00000010000000000000/0.00000002000000000000/g' Chr_${i}.chromo.rec > Chr_${i}.chromo.edit.rec
done
for i in {07..13} ;
do echo $i ;
sed 's/0.00000010000000000000/0.00000001700000000000/g' Chr_${i}.chromo.rec > Chr_${i}.chromo.edit.rec
done
for i in {14..24} ;
do echo $i ;
sed 's/0.00000010000000000000/0.00000001500000000000/g' Chr_${i}.chromo.rec > Chr_${i}.chromo.edit.rec
done

cat Chr_24.sample | tail -n+3 > test1
cut -d ' ' -f1 test1 > test2
cut -d ' ' -f2 test1 | cut -c1-3 > test3
cut -d ' ' -f3 test1 | sed 's/0/1/g' > test4
paste test2 test3 test4 > IndividualsOverview.txt
rm test*
echo -e "BJO\tR" >> PopOverview.txt
echo -e "SPI\tD" >> PopOverview.txt
echo -e "ROS\tD" >> PopOverview.txt

cp PopOverview.txt PopOverviewSurr.txt
echo -e "SPI\tR" >> PopOverviewSurr.txt
echo -e "ROS\tR" >> PopOverviewSurr.txt

for i in 02 07 12 17 22 24 ;
do echo ${i} ;  
ChromoPainterv2 -g Chr_${i}.chromo.phase -r Chr_${i}.chromo.edit.rec \
-t IndividualsOverview.txt -f PopOverviewSurr.txt 1 10 -s 0 -i 10 -in -iM -o output_estimate_EM_Chr_${i}
done

# need to change values individually in ChromoPainterv2EstimatedNeMutExtractEM.pl
for i in 02 07 12 17 22 24 ;
do echo ${i} ;  
tail -n+2 Chr_${i}.chromo.edit.rec | wc -l ;
done

#02
#1569514
#07
#385658
#12
#298243
#17
#92388
#22
#61256
#24
#28217

nano ChromoPainterv2EstimatedNeMutExtractEM.pl

module purge
module load Perl/5.34.0-GCCcore-11.2.0
perl ChromoPainterv2EstimatedNeMutExtractEM.pl
# n=16885.113 M=0.017381

for i in {01..24} ;
do echo ${i} ;
ChromoPainterv2 -g Chr_${i}.chromo.phase -r Chr_${i}.chromo.edit.rec \
-t IndividualsOverview.txt -f PopOverviewSurr.txt 0 0 -s 0 -n 16885.113 -M 0.017381 -o Chr_${i}.chromo.DonorVall
done

# need to change values individually in ChromoPainterOutputSum.pl
nano ChromoPainterOutputSum.pl
perl ChromoPainterOutputSum.pl Chr_ .chromo.DonorVall.chunklengths.out

module purge
module load Perl/5.34.0-GCCcore-11.2.0
for i in {01..24} ;
do echo ${i} ;
ChromoPainterv2 -g Chr_${i}.chromo.phase -r Chr_${i}.chromo.edit.rec \
-t IndividualsOverview.txt -f PopOverview.txt 0 0 -s 10 -n 16885.113 -M 0.017381 -o Chr_${i}.chromo.DonorVtarget
done

nano fastGLOBETROTTER.R
nano paramfile.txt
nano samplefile.txt
nano recomfile.txt

sbatch fastGlobe.sh

```
fastGlobe.sh

```
module load R/4.1.0-foss-2021a

Rscript fastGLOBETROTTER.R paramfile.txt samplefile.txt recomfile.txt 1 --no-save > SPI_ROS_BJO.fastGT.out

```

Bootstrapping

```
mkdir 1DateBoot
cd 1DateBoot

cp ../paramfile.txt .
cp ../samplefile.txt .
cp ../recomfile.txt .
cp ../fastGLOBETROTTER.R .
cp ../IndividualsOverview.txt .
cp ../Bjornoya.globetrotter.main.txt .
cp ../Bjornoya.globetrotter.main_curves.txt .
cp ../Chr_All.chromo.DonorVall.chunklengths.out .
cp ../Chr_*.chromo.DonorVtarget.samples.out .
cp ../Chr_*.chromo.edit.rec .

nano paramfile.txt

for i in {01..100} ;
do echo ${i} ;
sbatch fastGlobe_boot.sh ${i} ;
done

#do the same with 2DateBoot
mkdir 2DateBoot
cd 2DateBoot
#with same script etc. - edit the paramfile differently
nano paramfile.txt

```

fastGlobe_boot.sh

```bash


module load R/4.1.0-foss-2021a

mkdir tmp_${1}
cd tmp_${1}

cp ../paramfile.txt .
cp ../samplefile.txt .
cp ../recomfile.txt .
cp ../fastGLOBETROTTER.R .
cp ../IndividualsOverview.txt .
cp ../Bjornoya.globetrotter.main.txt .
cp ../Bjornoya.globetrotter.main_curves.txt .
cp ../Chr_All.chromo.DonorVall.chunklengths.out .
cp ../Chr_*.chromo.DonorVtarget.samples.out .
cp ../Chr_*.chromo.edit.rec .

Rscript fastGLOBETROTTER.R paramfile.txt samplefile.txt recomfile.txt 1 --no-save > SPI_ROS_BJO.fastGT.boot.out

mv Bjornoya.globetrotter.boot.txt Bjornoya.globetrotter.boot_${1}.txt
cp Bjornoya.globetrotter.boot_${1}.txt ../
cd ../
rm -r tmp_${1}

```

THEN

```bash
cd 1DateBoot
touch Bjornoya.globetrotter.boot_1date_values.txt 
for i in {01..100} ;
do echo ${i} ;
cat Bjornoya.globetrotter.boot_${i}.txt | cut -d ' ' -f2 | tail -1 >> Bjornoya.globetrotter.boot_1date_values.txt 
done

cd 2DateBoot
touch Bjornoya.globetrotter.boot_2date_values.txt 
for i in {01..100} ;
do echo ${i} ;
cat Bjornoya.globetrotter.boot_${i}.txt | cut -d ' ' -f2 | tail -1 > tmp1
cat Bjornoya.globetrotter.boot_${i}.txt | cut -d ' ' -f3 | tail -1 > tmp2
paste tmp1 tmp2 >> Bjornoya.globetrotter.boot_2date_values.txt 
done

```

