# Admixture


```bash
mkdir Admixture
cd Admixture

cp ../PCAngsd/PuffinAngsd_Chr_Autosomes.beagle.ldpruned.gz .

# NgsAdmix for K from 1 to 10
for K in $(seq 1 10) ;
do echo ${K};
for i in $(seq 1 50) ;
do sbatch NgsAdmix.sh ${K} ${i};
done ;
done ;


```

nano NgsAdmix.sh

```bash


mkdir temp.${1}.${2}
cd temp.${1}.${2}
cp ../PuffinAngsd_Chr_Autosomes.beagle.ldpruned.gz .

#making a random seed
R=$(echo $RANDOM % 100 | bc)
S=$(bc <<<"scale=0; ${R} * ${1} * ${2}")

#ngsAdmix
module load NGSadmix/32-GCC-7.3.0-2.30

Threads=16

NGSadmix -likes PuffinAngsd_Chr_Autosomes.beagle.ldpruned.gz -K ${1} -P ${Threads} -o PuffinAngsd_Chr_Autosomes.beagle.ldpruned_ngsAdmix_k${1}_n${2} -maxiter 5000 -seed ${S}

rm -r PuffinAngsd_Chr_Autosomes.beagle.ldpruned.gz
cp -r * ../
cd ../
rm -r temp.${1}.${2}

```

PARTIALLY LOCAL

```bash

#log likelihoods for best K
(for log in `ls *.log`; do grep -Po 'like=\K[^ ]+' $log; done) > logfile

#Zip file for Clumpak run
for i in 1 2 3 4 5 6 7 8 9 10 ;
do zip K${i}_PuffinAngsd_Chr_Autosomes.zip PuffinAngsd_Chr_Autosomes.beagle.ldpruned_ngsAdmix_k${i}_*.qopt ;
done ;
zip PuffinAngsd_Chr_Autosomes.zip K*_PuffinAngsd_Chr_Autosomes.zip

#use NgsAdmix2Clumpak.R

#sort file
sort -n -k1,1 logfile_formatted.txt | awk -F ' ' '{print $1"\t"$2}' > logfile_formatted_clumpak.txt

#then clumpak ; http://clumpak.tau.ac.il/bestK.html
# with logfile and zip file
# save output zipfolders as EvannoOut and ClumpakOut

#check best K's (Evanno) and select mean Qmatrix file based Clumpakk

awk '{print $6"\t"$7}' CLUMPAK/K=2/MajorCluster/CLUMPP.files/ClumppIndFile.output > K2_Clumpak_MajorQmatrix.txt
awk '{print $6"\t"$7"\t"$8}' CLUMPAK/K=3/MajorCluster/CLUMPP.files/ClumppIndFile.output > K3_Clumpak_MajorQmatrix.txt
awk '{print $6"\t"$7"\t"$8"\t"$9}' CLUMPAK/K=4/MajorCluster/CLUMPP.files/ClumppIndFile.output > K4_Clumpak_MajorQmatrix.txt

# then Admixture_GenoLike.R for Plot
```

EvalAdmix

```bash


#check which run got the highest likelihood
(for log in `ls *.log | grep k2`; do grep -Po 'like=\K[^ ]+' $log; done) > logfile_tmp1
(for log in `ls *.log | grep k2`; do echo $log; done) > logfile_tmp2
paste logfile_tmp1 logfile_tmp2 > logfile_k2
rm logfile_tmp1
rm logfile_tmp2
sort -n -r -k1,1 logfile_k2 | head -1 | awk '{print $2}' | awk -F '.' '{print $1"."$2"."$3}' > FilePrefix_k2

(for log in `ls *.log | grep k3`; do grep -Po 'like=\K[^ ]+' $log; done) > logfile_tmp1
(for log in `ls *.log | grep k3`; do echo $log; done) > logfile_tmp2
paste logfile_tmp1 logfile_tmp2 > logfile_k3
rm logfile_tmp1
rm logfile_tmp2
sort -n -r -k1,1 logfile_k3 | head -1 | awk '{print $2}' | awk -F '.' '{print $1"."$2"."$3}' > FilePrefix_k3

(for log in `ls *.log | grep k4`; do grep -Po 'like=\K[^ ]+' $log; done) > logfile_tmp1
(for log in `ls *.log | grep k4`; do echo $log; done) > logfile_tmp2
paste logfile_tmp1 logfile_tmp2 > logfile_k4
rm logfile_tmp1
rm logfile_tmp2
sort -n -r -k1,1 logfile_k4 | head -1 | awk '{print $2}' | awk -F '.' '{print $1"."$2"."$3}' > FilePrefix_k4

module purge
module load NGSadmix/32-GCC-7.3.0-2.30

for i in 2 3 4 ;
do cat FilePrefix_k${i} | while read line ;
do echo $line ;
evalAdmix -beagle PuffinAngsd_Chr_Autosomes.beagle.ldpruned.gz -fname ${line}.fopt.gz -qname ${line}.qopt -o k${i}.${line}.evaladmixOut.corres -P 10 ;
done
done


#THEN
# VisualizationEvalAdmix.R

```